/**************************************************
*   Author: Morrison
*   Date:  22 Oct 202020
**************************************************/

import javafx.application.Application;
import javafx.application.Platform;
import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.layout.BorderPane;
import javafx.scene.layout.HBox;
import javafx.scene.control.Button;
import javafx.scene.control.TextField;
import javafx.scene.control.TextArea;
import java.io.FileReader;
import java.io.File;
import java.io.BufferedReader;
import java.io.IOException;

public class FileViewer extends Application
{
    private TextArea ta;
    private Stage primary;
    File file;
    public FileViewer()
    {
        ta = new TextArea();
        ta.setEditable(false);
        ta.setStyle("-fx-font-family:Courier");
        file = null;
    }
    
    @Override
    public void init()
    {
    }

    @Override
    public void start(Stage primary)
    {
        this.primary = primary;
        BorderPane bp = new BorderPane();
        HBox hbox = new HBox();
        bp.setTop(hbox);
        buildControls(hbox);
        bp.setCenter(ta);
        primary.setScene(new Scene(bp, 600,600));
        primary.show();
    }

    @Override
    public void stop()
    {
    }
    private String getFileContents()
    {
        StringBuffer sb = new StringBuffer();
        if(!file.exists())
        {
            return (String.format("File %s is a heffalump!", file.getAbsolutePath()));
        }
        else if(file.isFile())
        {
            try
            {
                BufferedReader br = new BufferedReader(new FileReader(file.getAbsolutePath()));
                br.lines()
                  .forEach( line -> sb.append(line.replace("\t", "    ") + "\n"));
                br.close();
                return sb.toString();
            }
            catch(IOException ex)
            {
                ex.printStackTrace();
            }
        }
        else if(file.isDirectory())
        {
            sb.append(String.format("Contents of directory %si:\n", file.getAbsolutePath()));
            File[] contents = file.listFiles();
            for(File item : contents)
            {
                sb.append(item.getName() + "\n");
            }
            return sb.toString();


        }
        return "";
    }
    private void buildControls(HBox hbox)
    {
        TextField tf = new TextField();
        Button goButton = new Button("GO!");
        goButton.setOnAction( e ->
        {
            file = new File(tf.getText());
            ta.setText(getFileContents());
            primary.setTitle(file.getAbsolutePath());
        });
        Button quitButton = new Button("Quit");
        quitButton.setOnAction( e -> Platform.exit());
        hbox.getChildren().addAll(tf, goButton, quitButton);
    }
}
